package com.zsc.edu.gateway.modules.iot.tsl.service.impl;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.zsc.edu.gateway.exception.ConstraintException;
import com.zsc.edu.gateway.modules.iot.tsl.dto.EventDto;
import com.zsc.edu.gateway.modules.iot.tsl.entity.Event;
import com.zsc.edu.gateway.modules.iot.tsl.mapper.EventMapper;
import com.zsc.edu.gateway.modules.iot.tsl.query.EventQuery;
import com.zsc.edu.gateway.modules.iot.tsl.repo.EventRepository;
import com.zsc.edu.gateway.modules.iot.tsl.service.EventService;
import org.springframework.beans.BeanUtils;
import org.springframework.stereotype.Service;

/**
 * @author Yao
 */
@Service
public class EventServiceImpl extends ServiceImpl<EventRepository, Event> implements EventService {

    EventMapper mapper;
    EventRepository repo;


    /**
     * 新建物模型事件
     */
    @Override
    public Event create(EventDto dto) {
        if (repo.findByName(dto.getName()) != null) {
            throw new ConstraintException("该事件已存在！");
        }
        Event event = mapper.toEntity(dto);
        save(event);
        return event;
    }

    /**
     * 更新物模型事件
     */
    @Override
    public Event update(EventDto dto, Long id) {
        Event event = repo.selectById(id);
        BeanUtils.copyProperties(dto, event);
        updateById(event);
        return event;
    }

    /**
     * 分页查询物模型事件
     *
     * @param query 查询表单
     * @param page  分页参数
     */
    @Override
    public IPage<Event> page(Page<Event> page, EventQuery query) {
        return repo.page(page, query);
    }

    //    /**
//     * 根据产品ID查找事件
//     *
//     * @param productId 产品id
//     * @return
//     */
//    public List<Event> findByProductId(Long productId) {
//        return repo.findByProductId(productId);
//    }
    @Override
    public Event detail(Long id) {
        return repo.selectById(id);
    }
}
