package com.zsc.edu.gateway.modules.iot.tsl.service.impl;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.zsc.edu.gateway.modules.iot.tsl.dto.PropertyDto;
import com.zsc.edu.gateway.modules.iot.tsl.entity.Property;
import com.zsc.edu.gateway.modules.iot.tsl.mapper.PropertyMapper;
import com.zsc.edu.gateway.modules.iot.tsl.query.PropertyQuery;
import com.zsc.edu.gateway.modules.iot.tsl.repo.PropertyRepository;
import com.zsc.edu.gateway.modules.iot.tsl.service.PropertyService;
import jakarta.annotation.Resource;
import lombok.AllArgsConstructor;
import org.springframework.beans.BeanUtils;
import org.springframework.stereotype.Service;

/**
 * @author 15864
 */
@AllArgsConstructor
@Service
public class PropertyServiceImpl extends ServiceImpl<PropertyRepository, Property> implements PropertyService {

    PropertyMapper mapper;
    @Resource
    private final PropertyRepository repo;

    /**
     * 新建物模型属性
     */
    @Override
    public Property create(PropertyDto dto) {
        Property property = mapper.toEntity(dto);
        save(property);
        return property;
    }

    /**
     * 更新属性
     */
    @Override
    public Property update(PropertyDto dto, Long id) {
        Property property = repo.selectById(id);
        BeanUtils.copyProperties(dto, property);
        updateById(property);
        return property;
    }

    /**
     * 分页查询物模型属性
     *
     * @param query 查询表单
     * @param page  分页参数
     */
    @Override
    public IPage<Property> page(Page<Property> page, PropertyQuery query) {
        return repo.page(page, query);
    }

    //    /**
//     * 根据产品ID查找属性
//     *
//     * @param query 查询表单
//     * @return
//     */
//    public List<Property> findByProductIdAndIoType(PropertyQuery query) {
//        return repo.findByProductIdAndIoType(query.productId, query.type);
//    }
    @Override
    public Property detail(Long id) {
        return repo.selectById(id);
    }
}
