package com.zsc.edu.gateway.modules.iot.tsl.service.impl;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.zsc.edu.gateway.exception.ConstraintException;
import com.zsc.edu.gateway.modules.iot.tsl.dto.ServeDto;
import com.zsc.edu.gateway.modules.iot.tsl.entity.Serve;
import com.zsc.edu.gateway.modules.iot.tsl.mapper.ServeMapper;
import com.zsc.edu.gateway.modules.iot.tsl.query.ServeQuery;
import com.zsc.edu.gateway.modules.iot.tsl.repo.ServeRepository;
import com.zsc.edu.gateway.modules.iot.tsl.service.ServeService;
import jakarta.annotation.Resource;
import lombok.AllArgsConstructor;
import org.springframework.beans.BeanUtils;
import org.springframework.stereotype.Service;


/**
 * @author 15864
 */
@AllArgsConstructor
@Service
public class ServeServiceImpl extends ServiceImpl<ServeRepository, Serve> implements ServeService {

    ServeMapper mapper;
    @Resource
    private final ServeRepository repo;

    /**
     * 新建功能
     */
    @Override
    public Serve create(ServeDto dto) {
        if (repo.findByName(dto.getName()) != null) {
            throw new ConstraintException("该事件已存在！");
        }
        Serve entity = mapper.toEntity(dto);
        save(entity);
        return entity;
    }

    /**
     * 更新功能
     */
    @Override
    public Serve update(ServeDto dto, Long id) {
        Serve serve = repo.selectById(id);
        BeanUtils.copyProperties(dto, serve);
        updateById(serve);
        return serve;
    }

    /**
     * 分页查询功能
     *
     * @param query 查询表单
     * @param page  分页参数
     */
    @Override
    public IPage<Serve> page(Page<Serve> page, ServeQuery query) {
        return repo.page(page, query);
    }

    //
//    /**
//     * 根据产品ID查找服务
//     *
//     * @param productId 产品id
//     * @return
//     */
//    public List<Serve> findByProductId(Long productId) {
//        return repo.findByProductId(productId);
//    }
    @Override
    public Serve detail(Long id) {
        return repo.selectById(id);
    }
}
