package com.zsc.edu.gateway.modules.notice.query;

import com.zsc.edu.gateway.modules.notice.entity.MessageType;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;
import org.springframework.format.annotation.DateTimeFormat;

import java.time.LocalDateTime;

/**
 * @author zhuang
 */
@Data
@AllArgsConstructor
@NoArgsConstructor
public class AdminMessageQuery {
    /**
     * 用户ID
     */
    public Long userId;

    /**
     * 标题，模糊查询
     */
    public String title;

    /**
     * 消息创建时间区间起始
     */
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    public LocalDateTime createAtBegin;

    /**
     * 消息创建时间区间终止
     */
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    public LocalDateTime createAtEnd;
}
